<template>
  <div v-if="data">
    <div class="single-grid space-between">
      <div class="col-8">
        <Information
          :date="type === 'event' ? data.date : data.created_at"
          :location="data.location"
        />
        <div class="single-title">
          <span v-if="data.name">
            {{ data.name }}
          </span>
          <span v-else class="waiting">Enter title...</span>
          <Button
            v-if="user && data.user && user.id === data.user.id"
            icon
            variant="none"
            size="inline"
            @click="modals.edit = !modals.edit"
          >
            <svg-icon v-if="modals.edit == false" name="pencil" />
            <svg-icon v-else name="close" />
          </Button>
        </div>
        <div
          v-if="data.comment"
          class="single-description"
          v-html="data.comment"
        ></div>

        <Clients
          v-if="type == 'event'"
          :customer="data.customer"
          :author="data.user"
        />

        <div v-if="data.tags && type == 'album'" class="single-tags">
          <div v-for="(item, index) in data.tags" :key="index">
            <span v-html="item.tag.tag"></span>
          </div>
        </div>
      </div>

      <div
        v-if="data.payment_types && data.payment_types.length > 0"
        class="col-4 self-end"
      >
        <Payment :payment="data.payment_types" />
      </div>
    </div>

    <div class="single-grid space-between align-end">
      <div class="col-4">
        <div v-if="data.statistics" class="single-statistic">
          <div>
            <div class="single-statistic__top">{{ $t('events.income') }}</div>
            <div class="single-statistic__content">
              {{ data.statistics.income }}$
            </div>
          </div>

          <div>
            <div class="single-statistic__top">
              {{ $t('events.downloads') }}
            </div>
            <div class="single-statistic__content">
              {{ data.statistics.downloads }}
              <span>+{{ data.statistics.new_downloads }}</span>
            </div>
          </div>
          <div>
            <div class="single-statistic__top">{{ $t('events.visits') }}</div>
            <div class="single-statistic__content">
              {{ data.statistics.visits }}
              <span>+{{ data.statistics.visits }}</span>
            </div>
          </div>
        </div>
      </div>
      <div class="col-8 self-end">
        <div class="single-button" style="align-items: inherit">
          <div>
            <Button
              size="small"
              variant="primary"
              :to="localePath(`/${type}/${data.id}`)"
              target="_blank"
              style="height: 100%"
              :disabled="data.private"
            >
              <svg-icon style="margin: 0" name="external-link" />
            </Button>
          </div>
          <div>
            <Button
              size="inline"
              variant="grey"
              @click="modals.share = !modals.share"
              :disabled="data.private"
            >
              <span>{{ $t('buttons.share') }}</span>
              <svg-icon name="share" style="fill: #0065ff" />
            </Button>
          </div>
          <div>
            <Button
              size="inline"
              :variant="data.private ? 'success' : 'grey'"
              @click="updateItemPrivate"
              :disabled="
                user && data.user && user.id !== data.user.id ? true : false
              "
            >
              <span v-if="data.private">{{ $t('buttons.private') }}</span>
              <span v-else>{{ $t('buttons.open') }}</span>
              <svg-icon
                v-if="data.private == false"
                name="lock"
                style="fill: #00ffb3"
              />
              <svg-icon v-else name="lock_close" style="fill: #1b2234" />
            </Button>
          </div>
          <div v-if="user && data.user && user.id === data.user.id">
            <Button
              size="inline"
              variant="danger-opacity"
              @click="modals.delete = !modals.delete"
            >
              <span>{{ $t('buttons.delete') }}</span>
            </Button>
          </div>
        </div>
      </div>
    </div>

    <portal to="modal">
      <Modal v-model="modals.share">
        <template slot="title">{{ $t('share_link') }}</template>
        <ShareModal :url="`${type}/${data.id}`" />
      </Modal>

      <Modal v-model="modals.edit">
        <template v-if="type == 'event'" slot="title">
          {{ $t('events.edit_event') }}
        </template>
        <template v-else slot="title">
          {{ $t('events.edit_album') }}
        </template>
        <template slot="bottom">
          <Button size="small" @click="updateItem">
            {{ $t('settings.save') }}
            <svg-icon name="arrow-line" class="icon-radius" />
          </Button>
        </template>

        <div v-if="type == 'event'" class="modal__grid">
          <div>
            <div class="modal__input is-active">
              <span class="modal__label">{{ $t('events.date') }}</span>
              <el-input
                :value="
                  data.date ? format(new Date(data.date), 'dd MM yyyy') : null
                "
                v-mask="'##.##.####'"
                border
                line
                disabled
              />
            </div>
          </div>
          <div>
            <div class="modal__input is-active">
              <span class="modal__label">{{ $t('events.time') }}</span>
              <el-input
                :value="data.date ? format(new Date(data.date), 'HH:mm') : null"
                v-mask="'##:##'"
                border
                line
                disabled
              />
            </div>
          </div>
        </div>

        <div class="modal__input is-active">
          <span class="modal__label">{{ $t('events.name') }}</span>
          <el-input border line v-model="formData.name" />
        </div>
        <div class="modal__input is-active">
          <span class="modal__label">{{ $t('events.description') }}</span>
          <el-input
            type="textarea"
            :autosize="{ minRows: 1 }"
            border
            line
            v-model="formData.comment"
          />
        </div>

        <div
          class="modal__input"
          @click="modals.map = true"
          :class="{
            'is-active':
              newLocationName ||
              (formData.location && formData.location.display_name)
          }"
        >
          <span class="modal__label">{{ $t('events.location') }}</span>
          <el-input
            border
            line
            ref="input_location"
            :value="
              formData.location && !newLocationName
                ? [formData.location.city, formData.location.country]
                    .filter(e => !!e)
                    .join(', ')
                : newLocationName
            "
          />
        </div>

        <div v-if="type != 'event'" class="modal__input is-active">
          <span class="modal__label">{{ $t('events.tags') }}</span>
          <el-input
            v-if="formData.tags && formData.tags.length == 0"
            border
            line
            value="Coming soon..."
            :readonly="true"
            :disabled="true"
          />
          <div
            v-else
            class="el-input custom-line-select"
            style="
              flex-wrap: wrap;
              height: auto;
              padding-bottom: 0px;
              padding-right: 0;
              padding-top: 25px;
              font-size: inherit;
            "
          >
            <div
              :key="tagIndex"
              v-for="(item, tagIndex) in formData.tags"
              style="
                margin: 0 10px 10px 0;
                font-size: inherit;
                text-transform: capitalize;
              "
            >
              <el-tag
                :disable-transitions="false"
                @close="removeTags(item)"
                closable
                effect="dark"
              >
                <span style="font-size: 18px; line-height: 18px">
                  {{ item.tag.tag }}
                </span>
              </el-tag>
            </div>
          </div>
        </div>

        <!-- <div v-if="formData.tags">
            <div :key="tagIndex" v-for="(item, tagIndex) in formData.tags">
              <el-tag
                :disable-transitions="false"
                @close="removeTags(item)"
                closable
                effect="dark"
              >
                <span>{{ item.tag.tag }}</span>
              </el-tag>
            </div>
          </div> -->

        <div
          v-for="(item, index) in formData.payment_types"
          :key="index"
          :class="{
            modal__grid:
              item.payment_type !== 'DONATION' && item.payment_type !== 'FREE'
          }"
        >
          <div v-if="userPayment">
            <div
              class="modal__input"
              :class="{ 'is-active': item.payment_type }"
            >
              <span class="modal__label">{{ $t('events.payment') }}</span>
              <el-select border line v-model="item.payment_type">
                <el-option
                  v-for="item in userPayment"
                  :key="item.id"
                  :value="item.payment_type"
                  :label="useTranslate(item.payment_type)"
                ></el-option>
              </el-select>
            </div>
          </div>
          <div
            v-if="
              item.payment_type !== 'DONATION' && item.payment_type !== 'FREE'
            "
          >
            <div class="modal__input" :class="{ 'is-active': item.price >= 0 }">
              <span class="modal__label">{{ $t('events.price') }}</span>

              <el-input v-model="item.price" border line>
                <div>$</div>
              </el-input>
            </div>
          </div>
          <button
            v-if="formData.payment_types.length > 1"
            @click="removePayment(item)"
          >
            delete
          </button>
        </div>
        <AddPayment
          v-if="
            formData.payment_types &&
            formData.payment_types.length !== user.payment_types.length
          "
          @click="useAddPayment(formData.payment_types)"
        />

        <Map
          v-if="modals.map"
          :data="newLocationGeo || formData.location || user.location"
          type="edit"
          @closeMap="modals.map = false"
          :onCreate="onCreateLocation"
        />
      </Modal>
    </portal>

    <el-dialog title="Warning" :visible.sync="modals.delete" center>
      <Button size="inline" variant="success" @click="deleteItem">
        {{ $t('buttons.delete') }}
      </Button>
      <Button
        size="inline"
        variant="white-opacity"
        @click="modals.delete = false"
      >
        {{ $t('buttons.cancel') }}
      </Button>
    </el-dialog>
  </div>
</template>

<script lang="ts">
import {
  defineComponent,
  computed,
  ref,
  reactive
} from '@nuxtjs/composition-api'

import {
  useUpdateAlbumMutation,
  useUpdateEventMutation,
  useDeleteAlbumMutation,
  useCreateLocationMutation
} from '@/sdk/hooks'
import useAddPayment from '@/hooks/add-payment'
import useTranslate from '~/hooks/get-translate'
import Button from '@/components/ui/Button.vue'
import BackButton from '@/components/ui/BackButton.vue'
import Payment from '@/components/ui/Payment.vue'
import Clients from '@/components/ui/Clients.vue'
import Information from '@/components/ui/Information.vue'
import AddPayment from '@/components/ui/AddPayment.vue'
import Modal from '@/components/ui/Modal.vue'
import Map from '@/components/ui/Map.vue'

import elInput from '@/components/element/Input.vue'
import elCheckbox from '@/components/element/Checkbox.vue'
import elCheckboxGroup from '@/components/element/CheckboxGroup.vue'
import elTag from '@/components/element/Tag.vue'
import elDialog from '@/components/element/Dialog.vue'

import ShareModal from '@/components/modal/ShareModal.vue'
import { pick } from 'lodash'
import { format } from 'date-fns'

export default defineComponent<{
  data: any
  type: string
}>({
  name: 'PrivatePage',
  props: ['data', 'type'],
  components: {
    Button,
    BackButton,
    elTag,
    Payment,
    Clients,
    Information,
    AddPayment,
    Modal,
    Map,
    elDialog,
    elInput,
    elCheckbox,
    elCheckboxGroup,
    ShareModal
  },
  setup(props, { root }) {
    const user = computed(() => root.$accessor.auth.user)
    const formData = computed(() => props.data)
    const modals = ref({
      share: false,
      edit: false,
      map: false,
      delete: false
    })

    // map
    const newLocation = ref()
    const newLocationName = ref(null)
    const newLocationGeo = ref(null)
    const onCreateLocation = (data: any) => {
      modals.value.map = false
      newLocationName.value = data.location_name
      newLocation.value = data
      newLocationGeo.value = data.coordinates
    }

    // edit item
    const { mutate: UpdateAlbumMutate } = useUpdateAlbumMutation({})
    const { mutate: UpdateEventMutate } = useUpdateEventMutation({})
    const { mutate: updateGeo } = useCreateLocationMutation({})
    const updateItem = async () => {
      modals.value.edit = false
      if (newLocation.value) {
        await updateGeo({
          object: {
            id: newLocation.value.id,
            ...newLocation.value.geo,
            geo: {
              type: 'Point',
              coordinates: newLocation.value.coordinates
            }
          }
        })
      }
      if (props.type == 'album') {
        await UpdateAlbumMutate({
          id: root.$route.params.id as string,
          object: {
            ...pick(formData.value, ['name', 'comment']),
            location_id:
              newLocation?.value?.id || formData.value?.location_id || undefined
          },
          payment: formData.value?.payment_types.map((r: any) => ({
            album_id: root.$route.params.id,
            payment_type: r.payment_type,
            price: r.price || 0
          })),
          tags: formData.value?.tags.map((r: any) => ({
            album_id: root.$route.params.id,
            tag_id: r.tag_id
          }))
        })
      } else if (props.type == 'event') {
        await UpdateEventMutate({
          id: root.$route.params.id as string,
          object: {
            ...pick(formData.value, ['name', 'comment']),
            location_id:
              newLocation?.value?.id || formData.value?.location_id || undefined
          },
          payment: formData.value?.payment_types.map((r: any) => ({
            event_id: root.$route.params.id,
            payment_type: r.payment_type,
            price: r.price || 0
          }))
        })
      }
    }

    // delete item

    const { mutate: DeleteItemMutate } = useDeleteAlbumMutation({})
    const deleteItem = () => {
      DeleteItemMutate({ id: root.$route.params.id as string })
      root.$router.push(`/profile/photography`)
    }

    // change private

    const updateItemPrivate = async () => {
      props.data.private = !props.data.private
      if (props.type == 'album') {
        await UpdateAlbumMutate({
          id: root.$route.params.id as string,
          object: {
            private: props.data.private
          },
          payment: formData.value?.payment_types.map((r: any) => ({
            album_id: root.$route.params.id,
            payment_type: r.payment_type,
            price: r.price >= 0 ? r.price : 0
          })),
          tags: []
        })
      } else if (props.type == 'event') {
        await UpdateEventMutate({
          id: root.$route.params.id as string,
          object: {
            private: props.data.private
          },
          payment: formData.value?.payment_types.map((r: any) => ({
            event_id: root.$route.params.id,
            payment_type: r.payment_type,
            price: r.price >= 0 ? r.price : 0
          }))
        })
      }
    }

    // payment
    const userPayment = user.value?.payment_types
    const removePayment = (item: any) => {
      formData.value.payment_types.splice(
        formData.value.payment_types.indexOf(item),
        1
      )
    }

    // tags

    const removeTags = (item: any) => {
      // var index = formData.value.tags.indexOf(item)
      // if (index !== -1) {
      //   formData.value.tags.splice(index, 1)
      // }
    }

    return {
      useTranslate,
      useAddPayment,

      user,
      formData,
      updateItemPrivate,
      deleteItem,
      updateItem,

      modals,
      newLocationName,
      newLocationGeo,
      onCreateLocation,

      userPayment,
      removeTags,

      format,
      removePayment
    }
  }
})
</script>

<style lang="scss" scoped>
.single {
  &-grid {
    display: grid;
    grid-template-columns: repeat(12, 1fr);
    grid-row-gap: 30px;
    margin-bottom: 30px;

    @media (min-width: 1199.98px) {
      grid-gap: 35px;
      margin-bottom: 50px;
    }
    &.space-between {
      justify-content: space-between;
    }
    &.align-end {
      align-items: flex-end;
    }

    & {
      .col-3,
      .col-4,
      .col-5,
      .col-6,
      .col-7,
      .col-8,
      .col-12 {
        grid-column: span 12;
      }

      @media (min-width: 1199.98px) {
        & .self-end {
          justify-self: flex-end;
        }

        .col-3 {
          grid-column: span 3;
        }

        .col-4 {
          grid-column: span 4;
        }

        .col-5 {
          grid-column: span 5;
        }

        .col-6 {
          grid-column: span 6;
        }

        .col-7 {
          grid-column: span 7;
        }

        .col-8 {
          grid-column: span 8;
        }

        .col-12 {
          grid-column: span 12;
        }
      }
    }
  }

  &-title {
    font-size: 30px;
    line-height: 30px;
    color: #ffffff;
    display: flex;
    align-items: center;
    margin-bottom: 15px;

    span.waiting {
      color: #a6abb5;
    }

    &:last-child {
      margin-bottom: 0px;
    }

    @media (min-width: 1199.98px) {
      font-size: 55px;
      line-height: 55px;
    }

    ::v-deep .btn[icon] {
      width: 50px;
      height: 50px;
      border-radius: 50%;
      background: #272c3b;
      margin-left: 25px;
      padding: 0px;
      flex: none;

      svg {
        fill: #00ffb3;
        width: 13px;
        height: 13px;
      }
    }
  }

  &-description {
    font-size: 20px;
    line-height: 24px;
    letter-spacing: 0px;
    color: #9badd6;
    margin-bottom: 30px;

    @media (min-width: 1199.98px) {
      font-size: 24px;
      line-height: 36px;
    }
  }

  &-tags {
    display: flex;
    align-items: center;
    overflow-x: auto;
    overflow-y: hidden;
    margin-right: -30px;
    margin-left: -30px;
    padding-left: 30px;
    padding-right: 15px;
    white-space: nowrap;

    > div {
      padding-right: 15px;
      flex: none;
    }

    span,
    a {
      display: block;
      padding: 4px 15px;
      background: 0;
      border: 1px solid #0065ff;
      border-radius: 17px;
      text-align: left;
      font-weight: 500;
      font-size: 18px;
      line-height: 25px;
      letter-spacing: 0px;
      color: #9badd6;
    }
  }

  &-statistic {
    display: flex;
    align-items: flex-start;
    flex-wrap: nowrap;
    margin-right: -30px;
    margin-left: -30px;
    padding-left: 30px;
    overflow-x: auto;
    overflow-y: hidden;
    white-space: nowrap;

    > div {
      padding-right: 30px;
      flex: none;
    }

    @media (min-width: 1199.98px) {
      margin-right: -50px;

      > div {
        padding-right: 50px;
      }
    }

    &__top {
      font-weight: bold;
      font-size: 14px;
      line-height: 16px;
      color: #7683ad;
      text-transform: uppercase;
      margin-bottom: 5px;

      @media (min-width: 1199.98px) {
        font-size: 16px;
        line-height: 20px;
      }
    }

    &__content {
      display: flex;
      align-items: flex-start;
      font-weight: bold;
      font-size: 50px;
      line-height: 50px;
      letter-spacing: 0px;
      color: #ffffff;

      span {
        font-weight: 500;
        font-size: 14px;
        line-height: 20px;
        letter-spacing: 0px;
        color: #00ffb3;
        margin-left: 3px;
      }

      @media (min-width: 1199.98px) {
        font-size: 55px;
        line-height: 55px;

        span {
          font-size: 20px;
          line-height: 27px;
        }
      }
    }
  }

  &-button {
    display: flex;
    flex-wrap: wrap;
    flex-direction: column;

    @media (min-width: 1199.98px) {
      align-items: center;
      flex-direction: row;
    }

    > div {
      flex: 1;
      padding-bottom: 15px;

      @media (min-width: 1199.98px) {
        flex: 0 0 auto;
        padding-right: 20px;
        padding-bottom: 0px;
      }

      &:last-child {
        padding-right: 0px;
        padding-bottom: 0px;
      }
    }

    ::v-deep .btn {
      text-transform: uppercase;
      font-weight: bold;
      font-size: 16px;
      line-height: 20px;
      border-radius: 3px;
      padding: 20px 35px;

      &--size-small {
        padding-left: 20px;
        padding-right: 20px;
      }

      @media (max-width: 1199.98px) {
        width: 100%;
        display: flex;
      }
    }
  }
}

.feed {
  &-info {
    font-size: 0px;
    margin-bottom: 20px;

    @media (min-width: 1199.98px) {
      display: flex;
      align-items: flex-end;
      margin-bottom: 30px;
    }

    &.align-center {
      align-items: center;
    }

    &__title {
      font-size: 35px;
      line-height: 35px;
      letter-spacing: -0.88px;
      color: #ffffff;
      margin-right: 30px;
    }

    &__descr {
      font-weight: 500;
      font-size: 18px;
      line-height: 23px;
      letter-spacing: 0px;
      color: #9badd6;
    }
  }

  &__row {
    display: grid;
    grid-template-columns: repeat(12, 1fr);
    grid-template-rows: repeat(2, 1fr);
    grid-column-gap: 20px;
    grid-row-gap: 20px;
    font-size: 0px;

    ::v-deep .el-checkbox-group {
      display: grid;
      grid-template-columns: repeat(12, 1fr);
      grid-template-rows: repeat(2, 1fr);
      grid-column-gap: 20px;
      grid-row-gap: 20px;
      font-size: 0px;
      grid-column: span 12;
    }

    ::v-deep .el-checkbox {
      position: absolute;
      right: 20px;
      top: 15px;

      &__inner {
        margin: 0;

        &::after {
          border: 3px solid #272c3b;
          border-left: 0;
          border-top: 0;
          width: 7px;
          height: 11px;
          left: 12px;
          top: 8px;
        }
      }

      &__label {
        display: none;
      }

      &__input {
        &.is-checked {
          .el-checkbox__inner {
            background: #00ffb3;
          }
        }
      }
    }
  }

  &__item {
    grid-column: span 6;
    grid-row: span 1;
    position: relative;

    @media (min-width: 1199.98px) {
      grid-column: span 3;
    }

    img {
      width: 100%;
      object-fit: cover;
      height: 150px;
      border-radius: 5px;

      @media (min-width: 1199.98px) {
        height: 230px;
      }
    }

    @media (min-width: 1199.98px) {
      &:nth-child(1),
      &:nth-child(8),
      &:nth-child(11),
      &:nth-child(18),
      &:nth-child(21),
      &:nth-child(28) {
        grid-column: span 6;
        grid-row: span 2;

        img {
          height: 480px;
        }
      }
    }
  }
}
</style>
